//
// Hilfsprogramme fr den one-wire Bus
//


// ***** Umrechnung des Nachkommaanteils in das BCD-Format  *****
//	Parameter 1 wird in r24:r25 bergeben und enthlt das Byte mit dem Nachkommaanteil
//	Rueckgabewert: Nachkommaanteil * 6,25 gerundet
//	r2-r17, r28-r29 mssen gerettet werden! (gilt beim AVRGCC immer!)
//
//
.global malsechskommazweifuenf
.func malsechskommazweifuenf

// Aufruf: remainder = malsechskommazweifuenf(Scratch[0]); // Runden((Scratch[0]&0x0f)*6,25)

malsechskommazweifuenf:

	andi	r24, 0x0f		// Nachkommaanteil maskieren
	mov		r30, r24		// und merken
	lsl		r24				// *2
	mov		r31, r24
	lsl		r24				// *4
	add		r24, r31		// *4 + *2 = *6
	
	lsr		r30				// *0,5
	lsr		r30				// *0,25
	adc		r24, r30		// *6 + *0,25 + Rundung
	
	ret
	
.endfunc

.global maleinskommafuenfsechszweifuenf
.func maleinskommafuenfsechszweifuenf

// Aufruf: remainder = maleinskommafuenfsechszweifuenf(Scratch[0]); // Runden((Scratch[0]&0x0f)*1,5625)

maleinskommafuenfsechszweifuenf:

	andi	r24, 0x3f		// Nachkommaanteil maskieren
	mov		r30, r24		// und merken
	
	lsr		r30				// *0,5
	add		r24, r30		// *1 + *0,5
	lsr		r30				// *0,25
	lsr		r30				// *0,125
	lsr		r30				// *0,0625
	adc		r24, r30		// *1,5 + *0,0625 + Rundung
	
	ret
	
.endfunc



.end
