/*#######################################################################################
Unterprogramme zur Bedienung der Funksteckdosen

Copyright (C) 2006 Joachim Brke

#######################################################################################*/
unsigned char eeprom_read_byte_index (char nr, char Subindex);
unsigned char eeprom_read_byte_subindex (char Subindex);

//######################################################################################
// Den Funksteckdosencode der Steckdose[Index] in den Buffer schreiben 
// Index bezeichnet den Datensatz. Der Offset gibt den Beginn des Codes im Datensatz an
//
void store_code (char *buffer, char Offset)
{
	char j=3;											// drei Byte sind zu speichern
	do {
		char Data = Byte2Dbit(buffer);					// Die Umcodierung erfolgt in Assembler
		eeprom_write_byte((uint8_t *)(int)(Index<<4)+Offset++,Data);		// Byte ins EEPROM schreiben
		buffer += 4;									// vier ASCII-Zeichen werden in ein Byte gepackt
	} while (--j);
}

//######################################################################################
// Funksteckdose oder Port schalten
// Der Schaltcode gibt an, ob ein- oder ausgeschaltet werden soll
// Index bezeichnet den Datensatz
//
void schalte_IO (char nummer, char Schaltzustand)
{
	char Kennung = DALLAS[(int)nummer][0];
	
	if (Kennung==Steckdosenkennung){
		if (DALLAS[(int)nummer][1] != Schaltzustand){
			char Offset;
			if (Schaltzustand == EIN) Offset=0; else Offset=3;
			char x[] = {1,2,3};
			for (char j=0; j<3; j++) x[(int)j]=eeprom_read_byte_index(nummer,Offset++);
			sendeTelegramm(x);
		}
	}
	
	DALLAS[(int)nummer][1] = Schaltzustand;
	
	if (Kennung==Portkennung) {
		char Port = eeprom_read_byte_index(nummer,0);
		schalte_port(Port,Schaltzustand);
		DALLAS[(int)nummer][1] = read_port (Port);		// update
	}
}

//######################################################################################
// Abspeichern der Portdaten
// Die Leitungsnummer wird in 'data' angeliefert. 
// Der Port (A..D) mu vorher in VAo abgelegt worden sein.
//
void store_port (char data)
{
	VAp = data;											// Leitungsnummer merken
	char temp = (VAo<<4)|VAp;							// Port und Leitungsnummer zusammensetzen
	int Adresse=Index<<4;
	if ( temp != eeprom_read_byte_subindex(0) )		// wenn es nicht so im EEPROM steht
		eeprom_write_byte((uint8_t*)Adresse,temp); 	// jetzt schreiben
	DALLAS[Index][1] = read_port (temp);				// update
}
