/*#######################################################################################
AVR Webserver 

Copyright (C) 2006 Joachim Brke

In dieser Datei wird der GET-request bearbeitet
#######################################################################################*/

#include "main.h"
#include "uhr.h"
#include "OWI/OWIcrc.h"
#include "jb/funkUP.c"

//#######################################################################################
void get_request (char *Arbeitszeiger)
// Der Parameter zeigt auf den Anfang der auszuwertenden Daten; direkt hinter den Dateinamen
//
//#######################################################################################
{
	char
		unveraendert = 0xff,		// mu der EEPROM-Inhalt verndert werden?
		VAE = 0x7f,					// Variable mit Lschdaten, wird nur temporr bentigt
		VAH = 0,					// Variable mit Verschiebedaten, wird nur temporr bentigt
		i = 0, k, l,				// Laufvariable fr verschiedene Zwecke
		j = 0,
		*Endezeiger, *Merkzeiger;	// Bufferzeiger

	unsigned int 
		datum;
	
	// Arbeitszeiger hinter den Dateinamen setzen
	while ((*Arbeitszeiger != ' ') & (*Arbeitszeiger != '?'))	*Arbeitszeiger++;
	
	// Wir prfen alle Zeichen im HTTP-Get-Request vom aktuellen Arbeitszeiger bis zum nchsten Zeilenende
	// Es reicht aus, die erste Zeile des Get-Requests auszuwerten. Bei der Auswertung bis zum Bufferende wrden
	// die Variablen durch jene ersetzt, die in der Adresse der aufrufenden Seite stehen, also veraltet sind.
	//
	Endezeiger=Arbeitszeiger;					// Startbedingung fr die folgende Schleife setzen
	while (*Endezeiger++ != 13) {};			// CR suchen und damit nur die erste Zeile bearbeiten
	while (Arbeitszeiger < Endezeiger) {
		if (*Arbeitszeiger++ == 'V')			// Erst nach 'V' suchen
		if (*Arbeitszeiger++ == 'A')	{		// Dann Folgezeichen auf 'A' prfen
			k = *Arbeitszeiger++;				// Unterscheidungsbuchstabe merken
			if (k == 'a')	j = *Arbeitszeiger++;	// Subindex lesen
			if (*Arbeitszeiger++ == '=') {	// Jetzt auf '=' testen 
				
				// Der Arbeitszeiger zeigt nun auf das erste Zeichen des Parameterwertes
				Merkzeiger = Arbeitszeiger;		// brauchen wir noch zur Zahlenumwandlung oder zur Stringbearbeitung
				while(*Arbeitszeiger != '&' && *Arbeitszeiger !=' ') // Ende des Parameterwertes suchen 
					Arbeitszeiger++;			// um den Parameterwert in einen String umwandeln zu knnen, wird
				*Arbeitszeiger=0;				// der Parameterstring mit 0 abgeschlossen (=Stringende)
				
				if (k == 'N') {					// Sonderfall 'VAN' behandeln (Textstring fr EEPROM)
					for (i=8;i<16;i++) {			// wir haben im EEPROM 8 Stellen zur Verfgung
						if (*Merkzeiger != 0 ) { 			// solange wir nicht am Ende des Parameters sind ...
							if (*Merkzeiger=='+') l =' ';	// Leerzeichen vom Browser bekommen
							else if (*Merkzeiger=='*') {	// liegt ein Token vor ?
								l = *++Merkzeiger;			// ja, nchstes Zeichen adressieren und holen
								l -= (l>'9') ? 'A'-10 : '0';	// das Zeichen ist der Index des Tokens
							}
							else l = *Merkzeiger; 			// es ist kein Token sondern ein druckbares Zeichen
							*Merkzeiger++;					// Zeiger auf das nchste Zeichen
						}
						else l = 0xff;				// nicht benutzte Stellen im EEPROM mit 'FF' auffllen
						eeprom_write_byte((char *)(Index<<4)+i,l); // Zeichen bzw. Token im EEPROM ablegen
					}
				}
				
				else
				if (k == 'W') store_code(Merkzeiger,0);	// Textstring mit Code fr EIN
					
				else
				if (k == 'w') store_code(Merkzeiger,3);	// Textstring mit Code fr AUS
				
				else{
				datum = atoi(Merkzeiger);					// Parameterstring in eine Intergerzahl umwandeln
				
				if (k == 'a') eeprom_write_byte((uint8_t*)(Index<<4)+j-'0',datum); else // Beim Subindex schreiben
				
				if (k == '0') {VA4=0; VA5=0; VA6=0; unveraendert=0;} else	// Checkbox lschen
				if (k == '2') {VA2=datum; OCR2=datum;} else	// LED im PWM-Betrieb einstellen 
				if (k == '3') VA3 = datum; else
				if (k == '4') VA4 = datum; else
				if (k == '5') VA5 = datum; else
				if (k == '6') VA6 = datum; else				
				if (k == 'h') hh  = datum; else
				if (k == 'i') {VAi=datum; unveraendert=0;} else // IP-Adresse neu
				if (k == 'j') VAj = datum; else
				if (k == 'k') VAk = datum; else
				if (k == 'l') VAl = datum; else
				if (k == 'm') mm  = datum; else
				if (k == 'o') VAo = datum; else
				if (k == 'p') store_port(datum); else
				if (k == 'r') if (datum>9) VAr=9; else VAr = datum; else // Wiederholungen begrenzen
				if (k == 's') ss  = datum; else
				if (k == 'v') schalte_IO(Index,datum); else	// Steckdose oder Port schalten
				if (k == 'B') VAB = datum; else
				if (k == 'E') VAE = datum; else
				if (k == 'F') if (datum>8) VAF=0; else VAF = datum; else // Funlayer einschrnken
				if (k == 'H') VAH = datum; else
				if (k == 'L') Index = datum; else
				if (k == 'P') VAP = datum; else	// Bildformat
				if (k == 'R') VAR = datum; else
				if (k == 'S') VAS = datum; else	// Schaltschwelle
				{} // Leerer Begriff, damit alle vorstehenden Zeilen mit 'else' enden knnen.
				} // Ende der Fallabfrage
			} // Ende Gleichheitszeichen vorhanden
		} // Ende "VA"
	} // Ende while (ber alle Zeichen im Get-request)
	//
	// Wenn weitere Aktionen erforderlich sind, werden diese nun durchgefhrt
	//
	// Hier schalten wir die Dallas-Busleitungen ein
	if (VA4) DALLAS[0][0] |= OWI_PIN_4; else DALLAS[0][0] &= (~OWI_PIN_4);
	if (VA5) DALLAS[0][0] |= OWI_PIN_5; else DALLAS[0][0] &= (~OWI_PIN_5);
	if (VA6) DALLAS[0][0] |= OWI_PIN_3; else DALLAS[0][0] &= (~OWI_PIN_3);
	
	// Wenn Dallas-Optionen oder die IP-Adresse gendert wurden, jetzt das EEPROM aktualisieren
	if (!unveraendert) {
		eeprom_write_byte((char*)(char)0+IPoffset,VAi);		// Neue IP-Adresse ins EEPROM schreiben
		eeprom_write_byte((char*)(char)1+IPoffset,VAj);
		eeprom_write_byte((char*)(char)2+IPoffset,VAk);
		eeprom_write_byte((char*)(char)3+IPoffset,VAl);
		eeprom_write_byte((char*)(char)4+IPoffset,VA3);		// VA3 ins EEPROM schreiben
		eeprom_write_byte((char*)(char)5+IPoffset,DALLAS[0][0]);// DALLAS[0][0] ins EEPROM schreiben
		eeprom_write_byte((char*)(char)6+IPoffset,VAR);		// VAR ins EEPROM schreiben
		unsigned char CRC=0;	// neue Prfsumme ermitteln
		char j; // Schleifenvariable
		for (j=0; j<7; j++)	// ber 7 Byte
			CRC=OWI_ComputeCRC8(eeprom_read_byte((char*)(char)IPoffset+j),CRC);	// CRC byteweise errechnen
		eeprom_write_byte((char*)(char)7+IPoffset,CRC);		// und dann ins EEPROM schreiben
	}
	
	if ((VAH > 1) && (VAH < MAX_DEVICES))  {	// Datensatz verschieben im zulssigen Bereich ? 
		char l, // Schleifenvariable
		merkerZ, merkerQ;
		int ziel, quelle;
		quelle = VAH<<4;		// Byteadresse im EEPROM
		ziel = quelle-16;		// Byteadresse im EEPROM
		for (l=0;l<16;l++){
			merkerZ = eeprom_read_byte((uint8_t*)(ziel+l));
			merkerQ = eeprom_read_byte((uint8_t*)(quelle+l));
			if (merkerZ != merkerQ) {
				eeprom_write_byte((uint8_t*)(ziel+l),merkerQ);
				eeprom_write_byte((uint8_t*)(quelle+l),merkerZ);
			}
		}
		for (l=0;l<2;l++){
			merkerQ = DALLAS[(int)VAH][(int)l];	
			DALLAS[(int)VAH][(int)l]		= DALLAS[(int)VAH-1][(int)l];
			DALLAS[(int)VAH-1][(int)l]	= merkerQ;
		}
	}
	
	if ((VAE == Index)	&& (VAE < MAX_DEVICES)) {	// Datensatz lschen && im zulssigen Bereich ? 
		char l; // Schleifenvariable
		for (l=0;l<16;l++) eeprom_write_byte((uint8_t*)(VAE<<4)+l,0xff); // Datensatz mit "ff" berschreiben
		DALLAS[Index][0]=Leerkennung;	// Marke "Eintrag ist leer" setzen
		DALLAS[Index][1]=0xff;			// Eintrag auf "kein Thermometer" setzen
	}
	else
	if (VAE >= Kennungsgrenze) {	// Irgendetwas definieren ? 
		eeprom_write_byte((uint8_t*)(Index<<4)+7,VAE);
		DALLAS[Index][0]=VAE;
		DALLAS[Index][1]=0xff;			// Eintrag auf "kein Thermometer" setzen
	}
} // Ende get_request
