/*#######################################################################################
Dump-Unterprogramme zur Ausgabe eines Speicherdumps
Test der im EEPROM abgelegten IP-Adresse 

Copyright (C) 2005 Joachim Brke

#######################################################################################*/

#include "../main.h"
#include "../uip.h"
#include "../OWI/OWIPolled.h"
#include "../OWI/OWIcrc.h"

extern void checkEEPROMip (void);

//*************************************************************************************************
// IP-Adresse ist jetzt einstellbar	jb 26.07.2005
// Einstellungen werden im EEPROM gesichert jb 22.10.2005 
//
void checkEEPROMip(void)
{
	int i;			// Laufvariable
	
	unsigned char Feld[8];	// temporres Feld, um CRC-Unterprogram nutzen zu knnen
	for (i=0; i<8; i++)		// alle acht Bytes (IP mit CRC-Summe) ins RAM kopieren
		Feld[i]=eeprom_read_byte((char *)IPoffset+i);		// IP, Variablen und CRC aus dem EEPROM lesen

	if (!OWI_ComputeCRCn(Feld,8))	{				// Wenn CRC ok,
	
		VAi = Feld[0];
		VAj = Feld[1];
		VAk = Feld[2];
		VAl = Feld[3];
		
		VA3				= Feld[4];					//  Anzeigeoptionen setzen
		DALLAS[0][0]	= Feld[5];					//  aktive Busleitungen setzen
		VAR				= Feld[6];					//  refresh-Zeit fr Temperaturmessungen setzen
	}
	else {											// wenn CRC nicht ok, default-Werte benutzen
		VAi = 192;
		VAj = 168;
		VAk = 99;
		VAl = 199;
		VA3				= 0;						//  alle Bausteine anzeigen
		DALLAS[0][0]	= OWI_PIN_5;				//  aktive Busleitung ist D5 (evtl. mehrere durch | verknpfen)
		VAR				= 3;						//  refresh-Zeit fr Temperaturmessungen auf 3 s setzen
	}
	
	/* If uIP should use a fixed IP address, the settings are set in the
	 * uipopt.h file. If not, the macros uip_sethostaddr(),
	 * uip_setdraddr() and uip_setnetmask() should be used instead.
	
	uip_hostaddr[0] = (VAi << 8) | VAj;
	uip_hostaddr[1] = (VAk << 8) | VAl;
	*/

	DALLAS[0][0] &= erlaubteLeitungen;		// es sind nur bestimmte Busleitungen zulssig!
	BUSES = DALLAS[0][0];
	
	VAF	= 0;	// Funlayer auf 0 setzen;
	VAP	= 2;	// Bildgre auf 320*240 setzen (Schalter=2)
	
	VAr = 6;	// Funktelegramme werden 6 mal wiederholt
	
	// Initialisierung der LED-(PWM)-Ansteuerung an Pin 7 Port D
	LED_LINES		&= ~(1<<LED_PIN);	// Datenleitung auf "0" setzen
	LED_LINES_DIR	|= (1<<LED_PIN);	// Richtungsregister: LED_PIN = Output
	TCCR2	= 0x63;	// Phase correct PWM Mode fr OC2, CLK/32 d.h. 980 Hz Signalfrequenz bei 16 MHz Takt
	VA2		= 26;	// Startwert = 10% Helligkeit
	OCR2	= VA2;	// PWM-Register auf den Startwert setzen
	
	// Initialisierung der Portleitungen
	PORTB	&= ~(1<<4);			// Datenleitung auf "0" setzen
	DDRB	|= (1<<4);				// Port B 4 = Ausgang;

	PORTA	&= ~(1<<5|1<<6);		// Datenleitung auf "0" setzen
	DDRA	|= (1<<5|1<<6); 		// Port A 5,6 = Ausgang;

}
