//Globale Variablen

unsigned int sitecounter=0;
char Ausgabestring[24];
void token_out (unsigned char Q);

PGM_P tabellenzeiger;

PROGMEM char selected[]= {" selected"};
PROGMEM char checked[]	= {" checked"};

PROGMEM char DS[] = {"DS"};
PROGMEM char familycode[] = {
0x01,0x24,0x01,	// DS2401
0x02,0x14,0x25,	//	Aufbau der Tabelle: Familycode, Typ HOB, Typ LOB,
0x04,0x24,0x04,	
0x05,0x24,0x05,	//	Der Familycode entspricht dem ersten Byte der 64-bit-Dallas-Seriennummer
0x06,0x19,0x93,	//	Der IC-Typ wird im 2. und 3. Byte als vierstellige BCD-Zahl abgelegt
0x08,0x19,0x92,	//	Diese Zahl wird dann praktischerweise hexadezimal eingegeben
0x09,0x25,0x02,	0x0A,0x19,0x95,	0x0B,0x25,0x05,	0x0C,0x19,0x96,	0x0F,0x25,0x06,
0x10,0x18,0x20,	0x12,0x24,0x06,	0x14,0x24,0x30,	0x1A,0x19,0x63,	0x1B,0x24,0x36,
0x1C,0x28,0x04,	0x1D,0x24,0x23,	0x1F,0x24,0x09,	0x20,0x24,0x50,	// DS2450
0x21,0x19,0x21,	0x22,0x18,0x22,	// DS1822
0x23,0x24,0x33,	0x24,0x24,0x15,
0x26,0x24,0x38,	0x27,0x24,0x17,	0x28,0x18,0x20,	0x29,0x24,0x08,	0x2C,0x28,0x90,
0x2D,0x24,0x31,	0x2E,0x27,0x70,	0x30,0x27,0x60,	0x31,0x27,0x20,	0x33,0x24,0x32,
0x36,0x24,0x40,	0x37,0x19,0x77,	0x3A,0x24,0x13,	0x41,0x24,0x22,	0x51,0x27,0x51,
0x81,0x14,0x20,	0x84,0x24,0x04,	0x89,0x25,0x02,	0x8B,0x25,0x05,	0x8F,0x25,0x06,
0x00};			// Endezeichen

//############################################################################
// Ermitteln des Index
// Zeiger gibt an, welches Zeichen aus dem Programmspeicher gelesen werden soll
// Der Index wird zurckgegeben
//
unsigned char get_index (PGM_P Zeiger)
{
	char Z = pgm_read_byte(Zeiger);	// Zeichen nach Z laden
	if (Z=='*') Z=Index;				// '*' bedeutet: Globalen Index nutzen
	else Z -= Z>'9' ? 'A'-10 : '0';	// andernfalls Index berechnen
	return (Z);
}

//############################################################################
// Lesen eines Bytes aus dem Datensatz, der durch nr adressiert wird
// Der Subindex gibt die Position im Datensatz an
// Das gelesene Byte wird zurckgegeben
//
unsigned char eeprom_read_byte_index (char nr, char Subindex)
{
	return eeprom_read_byte((char*)(nr<<4)+Subindex);
}

//############################################################################
// Lesen eines Bytes aus dem Datensatz, der durch den globalen Index adressiert wird
// Der Subindex gibt die Position im Datensatz an
// Das gelesene Byte wird zurckgegeben
//
unsigned char eeprom_read_byte_subindex (char Subindex)
{
	return eeprom_read_byte_index(Index,Subindex);
}

//############################################################################
// Ausgabe eines Strings aus dem Flash in den HTML-Buffer
//
void string_out_P (PGM_P Z)
{
	char X;
	while ((X = pgm_read_byte(Z++)))		// solange wir kein Stringende (="0") haben ...
		if (X == '\032') 					// wenn <SUB>-Zeichen, Token ausgeben
			token_out(get_index(Z++));		// das Folgezeichen beinhaltet das Token
		else 
		*Schreibzeiger++ = X;				// sonst Zeichen ausgeben
}

//############################################################################
// Variable b als einstellige Dezimal- oder Hexadezimalziffer ausgeben
//
void byte_out (char b)
{	*Schreibzeiger++ = b>9 ? b+'A'-10 : b+'0'; }

//############################################################################
// Token mit dem Index "Q" ausgeben
//
void token_out (unsigned char Q)
{	string_out_P((PGM_P)pgm_read_word(&tokens[(int)Q])); }

//############################################################################
// Variable xx zweistellig mit fhrender 0 oder dreistellig dezimal ausgeben 
//
void dec_out2 (char xx)
{
	if (xx>99) {
		byte_out  (xx/100); 
		xx=xx%100; 
	}
	byte_out  (xx/10);
	byte_out  (xx%10);
}

//############################################################################
// Variable xx dezimal ausgeben (1, 2 oder 3-stellig ohne fhrende 0)
//
void dec_out (char xx)
{
	if (xx<10) byte_out (xx); 
	else dec_out2 (xx);
}

//############################################################################
// Variable xx zweistellig hexadezimal ausgeben
//
void hex_out (char xx)
{
	byte_out  (xx/16);	
	byte_out  (xx%16);
}


//############################################################################
// bei Bedarf "checked" in den Buffer schreiben 
// Zeiger gibt an, welches Zeichen aus dem Programmspeicher gelesen werden soll
// logic ist true oder false
//
void checked_out (PGM_P Zeiger,char logic)
{
	char i = pgm_read_byte(Zeiger);	// Folgezeichen einlesen ("-" oder "+")
	if (logic^(i=='-')) string_out_P(checked);	// 'checked' ausgeben
}

//############################################################################
// bei Bedarf "selected" in den Buffer schreiben 
// Zeiger gibt an, welches Zeichen aus dem Programmspeicher gelesen werden soll
// Der Vergleichswert wird mit dem Index verglichen
//
void selected_out (PGM_P Zeiger,char Vergleichswert)
{
	char i = pgm_read_byte(Zeiger);			// Folgezeichen einlesen
	if (i=='*') dec_out2(Vergleichswert);		// bei "*" Dezimalwert des Vergleichswertes ausgeben
	else {
		i -= i>'9' ? 'A'-10 : '0';				// zum Vergleichen in Integer umwandeln
		if (Vergleichswert==i) string_out_P(selected);	// bei bereinstimmung 'selected' ausgeben
	}
}

//############################################################################
// Funksteckdosencode der Steckdose[Index] in den Buffer schreiben 
// Der Offset gibt den Beginn des Codes im Flash-Speicher an
//
void code_out (char Offset)
{
	char j=3;						// drei Byte
	do {
		char Codeelement=eeprom_read_byte_subindex(Offset++);
		char k=4;					// vier Doppelbit pro Byte
		do {
			*Schreibzeiger++ = getbyte(Codeelement);
			Codeelement <<= 2;
		} while (--k);
	} while (--j);
}

//############################################################################
// Das Zeichen 'X' n-mal in den Buffer schreiben 
// X gibt das Zeichen an das n-Mal ausgegeben werden soll
//
void nZeichenX (char n, char X)
{ do *Schreibzeiger++ = X; while (--n); }

//############################################################################
// Ausgabe eines HTML-Strings abhngig von Variablen
// Wenn der neue Zustand vom bisherigen abweicht, 
//  wird ein Link mit dem Text EIN/AUS erzeugt, andernfalls werden Leerzeichen ausgegeben
// Wenn Schalter=0 wird "EIN" ausgegeben, sonst "AUS"
//
void string_out_EIN_AUS (char Schalter)
{
	if (DALLAS[Index][1]!=Schalter) {				// Link erzeugen
		string_out_P (PSTR("<a href=t.htm?VAL="));	// HTML-Vorspann
		dec_out2(Index);							// Index einfgen
		string_out_P (PSTR("&VAv="));				// Variable fr Schaltcode anhngen
		dec_out2(Schalter);							// Schaltcode einfgen
		*Schreibzeiger++ = '>';					// schlieende Klammer
		if (Schalter) string_out_P (PSTR("EIN")); 
			else string_out_P (PSTR("AUS"));
		string_out_P (PSTR("<a> "));				// Link abschlieen
	}
	else nZeichenX(4,' ');
}

//*************************************************************************************************
// Bereitstellen eines Bytes fr den Dump
//	adr gibt die gewnschte Adresse an
//  Das Byte wird zurckgegeben
//
char Dumpbyte (int adr)
{
	if		 (VAB==1) return eeprom_read_byte ((char*)adr);	// EEPROM
	else if (VAB==2) return RAM_read_byte    (adr);			// RAM
	else if (VAB==3) {										// 93LC46
		int Ergebnis = rtl8019_read_eeprom_word(adr>>1);
		if (adr & 0x01) return Ergebnis>>8; else return Ergebnis & 0x00FF;
	}
	else if (VAB==4) return FLASH_read_byte  (adr); 			// FLASH
	else if (VAB==5) return eeprom_read_byte ((char*)adr); 	// Dummy
	return (55);
}

//*************************************************************************************************
// Ausgeben eines Bausteinnamens. Im Namen knnen Abkrzungen stehen.
//	Nummer gibt den Index des Namen an, Kuerzel enthlt einen Schalter, mit dem zwischen
//  vollstndiger (*) und verkrzter Tokenausgabe (/) umgeschaltet werden kann.
//
void Name_out (char Nummer, char Kuerzel)
{
	char j, Data;
	for (j=8;j<16;j++) {									// 8 Byte aus demm EEPROM bearbeiten
		Data= eeprom_read_byte_index(Nummer,j);			// Zeichen aus dem EEPROM lesen
		if (Data==0xff) {}									// unbesetzt
		else if (Data>=' ') *Schreibzeiger++ =Data;		// ASCII-Zeichen ausgeben
		else if (Kuerzel=='/') {							// Token verkrzt ausgeben
			*Schreibzeiger++ ='*';							// '*' ausgeben
			Data += Data>9 ? 'A'-10 : '0';					// Tokennummer auf Basis 36 umrechnen
			*Schreibzeiger++ =Data;						// Tokennummer ausgeben
		}
		else if (Kuerzel=='*')	token_out(Data);		// Token vollstndig ausgeben
	}
}

//*************************************************************************************************
// Ausgeben eines Bausteinnamens mit der Nummer.
//	Nummer gibt den Index des Namen an
//
void Nr_Name_out (char Nummer, char Kuerzel)
{
	dec_out2(Nummer);					// [01:Name des Satzes 01]
	*Schreibzeiger++ =':';
	Name_out (Nummer,Kuerzel);
}
