/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

#######################################################################################*/

#ifndef _MAIN_H
 #define _MAIN_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include <avr/eeprom.h>

#include "usart.h"
#include "jb/funk.h"
#include "OWI/OWIPolled.h"

extern	 int checksum	(unsigned char * ,unsigned int,unsigned long);
extern	void OWI_check	(void);
extern	void OWI_init	(void);
extern void checkEEPROMip	(void);

extern	char malsechskommazweifuenf	(char);		// One-Wire_interface (OWI.S)
extern	char maleinskommafuenfsechszweifuenf(char);		// One-Wire_interface (OWI.S)
#define ALT 0	// ALT = 1 alter Code ALT = 0 neuer Code
extern void sendeTelegramm	(char *Datenfeld);		// Funkfernsteuerung (Funk.S)
extern char Byte2Dbit		(char *Datenfeld);		// Funkfernsteuerung (Funk.S)
extern char getbyte		(char);				// Funkfernsteuerung (Funk.S)
extern char read_port		(char Portleitung);					// Portsteuerung (Funk.S)
extern void schalte_port	(char Portleitung, char Schaltcode);	// Portsteuerung (Funk.S)
extern char RAM_read_byte		(int Adresse);		// Dump
extern char FLASH_read_byte	(int Adresse);		// Dump
extern unsigned int rtl8019_read_eeprom_word(unsigned char adr);
extern void schalte_IO (char nr, char Schaltcode);		// Funk-UP

unsigned char	VA0;				// temp. Variable
unsigned char	VA2;				// LED-Status
unsigned char	VA3;				// Dallas-Ausgabeschalter
unsigned char	VA4;				// Status der one-wire Busleitung 4
unsigned char	VA5;				// Status der one-wire Busleitung 5
unsigned char	VA6;				// Status der one-wire Busleitung 6
unsigned char	VA7;				// Index fr Namensseite
unsigned char	VAi;				// neues Adrebyte 1
unsigned char	VAj;				// neues Adrebyte 2
unsigned char	VAk;				// neues Adrebyte 3
unsigned char	VAl;				// neues Adrebyte 4
unsigned char	VAo;				// Port (A..D)
unsigned char	VAp;				// Leitung (0..7)
unsigned char	VAr;				// Wiederholung der Funktelegramme
unsigned char	VAv;				// Steckdose schalten
unsigned char	VAB;				// Schalter fr Dump (EEPROM oder RAM)
unsigned char	VAR;				// refresh-Zeit
unsigned char	VAF;				// funlevel
unsigned char	VAP;				// Bildformat
unsigned char	Index;				// globaler Index fr HTML-Schleifen
unsigned int	Index16;
PGM_P Wiederholzeiger;						//
char *Schreibzeiger;



// Leuchtdiodenport festlegen
#define LED_LINES			PORTD	// Port mit der LED
#define LED_LINES_DIR		DDRD	// Richtungsregister (Eingang oder Ausgang)
#define LED_PIN				7		// Pin an dem die LED angeschlossen ist


// Festlegungen fr das one-wire-interface
#define MAX_DEVICES 		31       		// maximale Anzahl der Dallas-Bausteine + 1
#define erlaubteLeitungen	(OWI_PIN_3 | OWI_PIN_4 | OWI_PIN_5) // zulssige one-wire Busleitungen

// Marken fr Datentabelle
#define Kennungsgrenze		240			// F0
#define Schaltuhrkennung	250			// FA
#define Speicherkennung		251			// FB
#define Thermostatkennung	252			// FC
#define Portkennung			253			// FD
#define Steckdosenkennung	254			// FE
#define Leerkennung			255			// FF

#define EIN					128			// 80
#define AUS					0			// 00

#define DS1820_FAMILY_ID	0x10 
#define DS1822_FAMILY_ID	0x20
#define DS18B20_FAMILY_ID	0x28
#define DS2430_FAMILY_ID	0x14 
#define DS2450_FAMILY_ID	0x20 
#define DS2890_FAMILY_ID	0x2c
unsigned char BUSES; 						// benutzte Busleitungen (evtl. mehrere Bits durch | verknpfen)
unsigned char	DALLAS[MAX_DEVICES][2];	// Platz fr MAX_DEVICES-1 Dallaschips



//Festlegungen zum EEPROM-Inhalt
#define IPoffset	8


//Festlegungen fr die Webcam
#define ETB 0x17								//End of Transmission Block
#define CAM_BUFFER_LEN 512						//buffer for webcam
extern unsigned char webcam_busy_forconn;	//some webcam control stuff:
extern int webcam_buffer_empty;
extern unsigned char webcam_pic_end;
extern unsigned char webcam_tmp;

#define TIMER_PRESCALE    1024

#endif //_MAIN_H






